<?php
import("php-ofc-library/open-flash-chart.php");

class diabetes extends spController
{

    //当前首页
    public function index()
    {
        $userObj = spClass("lib_diabetes_blood"); // 实例化diabetes_blood类
        $conditions = array( 'username' => $_SESSION["userinfo"]["username"] ); 
        $this->diabetes_blood = $userObj->findAll($conditions, "ctime DESC");
        $this->username = $_SESSION["userinfo"]["username"];
        $this->addinfo = array('datetime' => time());     
    }
    
        //当前首页
    public function user()
    {
        $userObj = spClass("lib_diabetes_blood"); // 实例化diabetes_blood类
        $this->username = $this->spArgs("username");
        $conditions = array( 'username' => $this->username );
        $this->diabetes_blood = $userObj->findAll($conditions, "ctime DESC");

        $this->addinfo = array('datetime' => time());     
    }
    //syncdata
    public function data()
    {
        $userObj = spClass("lib_diabetes_blood"); // 实例化diabetes_blood类
        if( $conditions = $this->spArgs("username") )
        {
        		$diabetes_blood = $userObj->findAll(array('username'=>$conditions), "ctime ASC");
        		foreach($diabetes_blood as $item)
        		{
        				echo($item['id'].",".$item['ctime'].",".$item['value']."\n");
        		}
        }    
    }
    
    //折线图JSON数据
    public function blood_line()
    {
		$currtime = time()+10800;
		$x_min = $currtime-2592000; //30 days
        $act_min = strtotime("2011-11-28");
        
        if($x_min < $act_min)
        {
            $x_min = $act_min;
        }

        $title = new title(strftime("%Y-%m-%d", $x_min) . "~" . strftime("%Y-%m-%d", $currtime));
        $title->set_style( "font-size: 25px" );
        $blue = "#80FFFF";
        $light_blue = "#0080FF";
        $green = "#00C400";
        $yellow = "#FFFF00";
        $red = "#FF0000"; 
        
        $hl = new shape($blue);
        $hl->append_value(new shape_point($x_min, 0));
        $hl->append_value(new shape_point($x_min, 3.9));
        $hl->append_value(new shape_point($currtime, 3.9));
        $hl->append_value(new shape_point($currtime, 0));

        $hnl = new shape($light_blue);
        $hnl->append_value(new shape_point($x_min, 3.9));
        $hnl->append_value(new shape_point($x_min, 4.4));
        $hnl->append_value(new shape_point($currtime, 4.4));
        $hnl->append_value(new shape_point($currtime, 3.9));
        
        $hg = new shape($green);
        $hg->append_value(new shape_point($x_min, 4.4));
        $hg->append_value(new shape_point($x_min, 7));
        $hg->append_value(new shape_point($currtime, 7));
        $hg->append_value(new shape_point($currtime, 4.4));
        
        $hnh = new shape($yellow);
        $hnh->append_value(new shape_point($x_min, 7));
        $hnh->append_value(new shape_point($x_min, 10));
        $hnh->append_value(new shape_point($currtime, 10));
        $hnh->append_value(new shape_point($currtime, 7));
        
        $hh = new shape($red);
        $hh->append_value(new shape_point($x_min, 10));
        $hh->append_value(new shape_point($x_min, 16));
        $hh->append_value(new shape_point($currtime, 16));
        $hh->append_value(new shape_point($currtime, 10));
    
        $b1 = new line("#000000");

        $userObj = spClass("lib_diabetes_blood"); // 实例化diabetes_blood类
        $conditions = array( 'username' => $this->spArgs("username") ); 
        $bloodlist = $userObj -> findAll($conditions, "ctime DESC");
        foreach($bloodlist as $item)
        {
            if($item['ctime'] < $x_min)
            {
                break;            
            }
            $b1->append_value(array('x'=>$item['ctime'], 'y'=>$item['value']));
        }
        

        $dot = new dot();
        $dot->halo_size(2);
        $dot->size(2);
        $dot->tooltip('#date:Y-m-d H:i#<br>#y#');
        $b1->set_default_dot_style($dot);
    
        $y = new y_axis();
        $y->set_range(0, 16, 2 );

        $x = new x_axis();
        $x->set_range($x_min, $currtime);
        $x->set_steps( 86400 );
        $labels = new x_axis_labels();
        // we have points at every X location, so label each X location
        $labels->set_steps(86400);
        $labels->visible_steps(1);
        $labels->text('#date#');
        // only display every other label (every other day)
        //$labels->visible_steps(2);
        $labels->rotate(-45);
        
        // finally attach the label definition to the x axis
        $x->set_labels($labels);

        $title = new title(strftime("%Y-%m-%d", $x_min) . "~" . strftime("%Y-%m-%d", $currtime));

        $chart = new open_flash_chart();
        $chart->set_title( $title );
        $chart->add_element( $b1 );
        $chart->add_element( $hl );
        $chart->add_element( $hnl );
        $chart->add_element( $hg );
        $chart->add_element( $hnh );
        $chart->add_element( $hh );
        
        $chart->set_y_axis( $y );
        $chart->set_x_axis( $x );
                    
        echo $chart->toPrettyString();

    }
    
    //饼图JSON数据    
    public function blood_pie()
    {
        $p = new pie();
        $userObj = spClass("lib_diabetes_blood"); // 实例化diabetes_blood类
        $conditions = array( 'username' => $this->spArgs("username") ); 
        $bloodlist = $userObj -> findAll($conditions, "ctime ASC");

        $low = 0;
        $nearlow = 0;
        $normal = 0;
        $nearhigh = 0;
        $high = 0;
                
        foreach($bloodlist as $item)
        {
            if($item['ctime'] < strtotime("2011-11-28"))
            {
                continue;
            }
            if($item['value'] >= 10.0)
            {
                $high++;
            }
            elseif($item['value'] > 7.0)
            {
                $nearhigh++;
            }
            elseif($item['value'] >= 4.4)
            {
                $normal++;
            }
            elseif($item['value'] > 3.9)
            {
                $nearlow++;
            }
            else
            {
                $low++;
            }
            
        }
        
        $blue = "#80FFFF";
        $light_blue = "#0080FF";
        $green = "#00C400";
        $yellow = "#FFFF00";
        $red = "#FF0000"; 
        
        $p->set_tooltip("#val# of #total#<br>#percent#");
        $p->set_alpha(0.5);
        $p->set_values(array($low, $nearlow, $normal, $nearhigh, $high));
        $p->set_colours(array($blue, $light_blue, $green, $yellow, $red));
        $p->set_animate(TRUE);
        $p->add_animation(new pie_bounce(15));
        

        $min = $bloodlist[0]['ctime'];
        $max = $bloodlist[count($bloodlist)-1]['ctime'];
        $title = new title(strftime("%Y-%m-%d", $min) . "~" . strftime("%Y-%m-%d", $max));
        
        $chart = new open_flash_chart();
        $chart->set_title( $title );
        $chart->add_element( $p );
        
        echo $chart->toPrettyString();     
    }
    
    //添加新记录 
    public function add()
    {

        $username = $_SESSION["userinfo"]["username"];
        $ctime = strtotime(($this -> spArgs("ctime")));
        $value = floatval($this -> spArgs("value"));
        $comment = $this -> spArgs("comment");

        $libObj = spClass("lib_diabetes_blood"); // 实例化diabetes_blood类
        $newrow = array('username' => $username, 'ctime' => $ctime, 'value' => $value, 'comment' => $comment);

        //检查是否重复
        $rec = $libObj -> find(array('username' => $username, 'ctime' => $ctime));
        if($rec)
        {
            if($rec['value'] == $value)
            {
                $this->success("此记录已存在", spUrl("diabetes","index"));;
            }
            else
            {
                $libObj -> update(array('id' => $rec['id']),$newrow);
                $this->success("更新了一条记录", spUrl("diabetes","index"));
            }
        }
       
        $result = $libObj -> create($newrow);
        if($result != FALSE)
        {
            $this->jump(spUrl("diabetes","index"));
        }
        else
        {
            $this->error("添加记录失败", spUrl("diabetes","index"));
        }
        
    }
    
    //删除记录
    public function del()
    {
        $username = $_SESSION["userinfo"]["username"];
        if($id = intval($this -> spArgs("id")))
        {
            $libObj = spClass("lib_diabetes_blood"); // 实例化diabetes_blood类
            $libObj->delete(array('id'=>$id));
            $this->jump(spUrl("diabetes","index"));
        }
    }
}
